#include <doors.h>
#include <compat.h>
#include <kbd.h>
#include <system.h>

#include <kbqlib.hc>	// necessary to differentiate between the asm header
						//  and the c header
int _ti89;

int kbqlib__0001();	// kbqclr
int kbqlib__0002();	// kbqget
int kbqlib__0003();	// kbqhit
int kbqlib__0004();	// kbqput

int kbqlib__0003()
{
	register int key;
	
	if (TIOS_entries<937) {		// If it does not have the necessary ROM CALL,
		key=kbhit();			// we are on a TI-89+ with AMS 1.00, so use
		return key;				// a different call.
	} else {
		register void *kbq=kbd_queue();

		if (OSqinquire(&key,kbq)) {
			return key;				//key exists
		} else {
			return 0;				//key does not exist
		}
	}
}

int kbqlib__0001()
{
	if (TIOS_entries<937) {
		GKeyFlush();
		return 0;
	} else {
		register void *kbq=kbd_queue();
		register int key;

		do {} while ((!OSdequeue(&key,kbq))!=0);	//OSqclear does not work correctly
													//in this instance, so I just use
													//OSdequeue until the buffer is clear
		return 0;
	}
}

int kbqlib__0002()
{
	register int key;
	
	if (TIOS_entries<937) {
		key=kbhit();
		if (key!=0) {
			key=ngetchx();
		}
		return key;
	} else {
		register void *kbq=kbd_queue();

		if (!OSdequeue(&key,kbq)) {
			return key;				//successful
		} else {
			return 0;				//kbq_queue is empty
		}
	}
}

int kbqlib__0004(register int key)
{
	if (TIOS_entries<937) {
		pushkey(key);
		return 0;
	} else {
		register void *kbq=kbd_queue();

		if (OSenqueue(key,kbq)) {
			return key;				//successful
		} else {
			return 0;				//kbq_queue is full
		}
	}
}		


void _main() {					// dummy program made so that
	kbqhit();					// I can find the entry points
	kbqclr();					// of the procedures when I
	kbqget();					// disassemble it.
	kbqput(500);
	return;
}

